// AsyncWininetDlg.cpp : implementation file
//

#include "stdafx.h"
#include "AsyncWininet.h"
#include "AsyncWininetDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif

#include "Wininet.h"


// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	enum { IDD = IDD_ABOUTBOX };

	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support

// Implementation
protected:
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
END_MESSAGE_MAP()


// CAsyncWininetDlg dialog




CAsyncWininetDlg::CAsyncWininetDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CAsyncWininetDlg::IDD, pParent)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CAsyncWininetDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_BUTTON1, m_buttonDownload);
	DDX_Control(pDX, IDC_EDIT1, m_editURL);
	DDX_Control(pDX, IDC_EDIT2, m_editReceived);
}

BEGIN_MESSAGE_MAP(CAsyncWininetDlg, CDialog)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	//}}AFX_MSG_MAP
	ON_BN_CLICKED(IDC_BUTTON1, &CAsyncWininetDlg::OnBnClickedButton1)
END_MESSAGE_MAP()


// CAsyncWininetDlg message handlers

BOOL CAsyncWininetDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	// TODO: Add extra initialization here

	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CAsyncWininetDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CAsyncWininetDlg::OnPaint()
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this function to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CAsyncWininetDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}


void CAsyncWininetDlg::OnBnClickedButton1()
{
	m_buttonDownload.EnableWindow(FALSE);

	DWORD dwID = 0;
	CreateThread(NULL, 0, (LPTHREAD_START_ROUTINE) ThreadFunc, this, 0, &dwID);
}

DWORD CAsyncWininetDlg::ThreadFunc(LPVOID lpvd)
{
	CAsyncWininetDlg* pDlg = (CAsyncWininetDlg*) lpvd;

	TCHAR sz[MAX_PATH];
	pDlg->m_editURL.GetWindowText(sz, MAX_PATH);

	TCHAR* pHost = sz;
	TCHAR* pPage = _tcschr(pHost, '/');
	if (!pPage) pPage = _T("/");
	else
	{
		pPage[0] = 0;
		++pPage;
	}

	CWininet myWininet;
	if (myWininet.Connect(pHost))
	{
		if (myWininet.SendRequest(pPage, _T("")))
		{
			CString strBuff;
			char szBuff[1024];
			int nLen;
			while ((nLen = myWininet.Read((PBYTE)szBuff, 1024)) > 0)
			{
				szBuff[nLen] = 0;
				strBuff += szBuff;
			}

			pDlg->m_editReceived.SetWindowText(strBuff);
		}
		else
			pDlg->MessageBox(_T("Send Request Error"), 0,  MB_ICONERROR);


	}
	else
		pDlg->MessageBox(_T("Connection Error"), 0,  MB_ICONERROR);



	pDlg->m_buttonDownload.EnableWindow(TRUE);


	return 0;
}
